using System;
using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using UnityEngine.UI;
using System.Linq;

//Credits: 
//Based extensively on work from Redeyes' DiviningForeskin (https://hub.virtamate.com/resources/diviningforeskin.33609/) (which in turn was based on ToumeiHitsuji's DiviningRod https://hub.virtamate.com/resources/diviningrod.8992/) and Hazmhox's VAMMoan https://hub.virtamate.com/resources/vammoan.3134/. 
//Thank you for inspiring me!

namespace RunRudolf
{
public class RealisticForeskin : MVRScript
{
    protected struct OtherPersonInfo
    {        
        public Atom PersonAtom;
        public bool IsFemale;
        public bool enabled;
        public Component LHandTarget;
        public Component RHandTarget;
        public Component LFootTarget;
        public Component RFootTarget;
        public Component ChestTarget;
        public Component MouthTarget;
        public Component VaginaTarget;
        public Component AnusTarget;
    }
    protected List<OtherPersonInfo> _otherPersons = new List<OtherPersonInfo>();
    protected FreeControllerV3 _penisBase;
    protected FreeControllerV3 _penisTip;
    
    protected DAZCharacterSelector Selector;
    protected static DAZMorph foreskinbasemorph_choice;
    //protected static DAZMorph foreskinbasemorph2_choice;   
    protected static DAZMorph foreskinmorph1_choice;
    protected static DAZMorph foreskinmorph2_choice;
    protected static DAZMorph foreskinmorph3_choice;
    protected static DAZMorph foreskinmorph4_choice;

    protected float last_foreskinmorph1_choice_inactive;
    protected float last_foreskinmorph2_choice_inactive;
    protected float last_foreskinmorph3_choice_inactive;
    protected float last_foreskinmorph4_choice_inactive;
    protected float erection;

    protected bool targetIsNearer;
    protected Vector3 targetOffset;
    protected string targetType;
    protected float targetDistance;
    protected float targetDistance2;
    protected float targetDistance3; 
    protected float sumtargetDistance;
    protected float sumtargetDistance1;
    protected float sumtargetDistance2;
    protected float sumtargetDistance3; 
    protected float sumtargetDistance_selected;
    protected float tiptargetDistance;
    protected float tiptargetDistance1;
    protected float tiptargetDistance2;
    protected float tiptargetDistance3;
    protected float tiptargetDistance_selected;  
    protected float share_of_targetDistance;
    protected float _targetTipToBaseDistance;
    protected bool isSceneLoaded = false;
    protected bool morphs_got = false;
    private JSONStorableBool enableTesting;
    private JSONStorableBool debug;

    protected JSONStorableFloat foreskinmorph1_min_JSON_base = new JSONStorableFloat("Min Hoodie Retraction", 0.0f, 0.0f, 1.0f, false); 
    protected JSONStorableFloat foreskinmorph1_min_JSON = new JSONStorableFloat("Min Hoodie Retraction Current Level", 0.0f, 0.0f, 1.0f, false); //dynamically adjusted morph 1 minimum based on erection level
    protected JSONStorableFloat foreskinmorph1_max_JSON = new JSONStorableFloat("Max Hoodie Retraction", 0.95f, 0.0f, 1.0f, false);
    protected JSONStorableFloat foreskinmorph2_min_JSON = new JSONStorableFloat("Min Hoodie More Retraction", 0.0f, 0.0f, 1.0f, false);
    protected JSONStorableFloat foreskinmorph2_max_JSON = new JSONStorableFloat("Max Hoodie More Retraction", 1.0f, 0.0f, 1.0f, false);
    protected JSONStorableFloat Min_Penis_Skin3AmountJSON = new JSONStorableFloat("Min Shaft Skin Amount", 0.0f, 0.0f, 1.0f, false);
    protected JSONStorableFloat Max_Penis_Skin3AmountJSON = new JSONStorableFloat("Max Shaft Skin Amount", 0.2f, 0f, 1.0f, false);
    protected JSONStorableFloat Red_Penis_Skin3AmountJSON = new JSONStorableFloat("Shaft Skin Delay", 0.25f, 0f, 1f, false);
    protected JSONStorableFloat foreskinmorph4_min_JSON = new JSONStorableFloat("Min Glans", -1.0f, -1.0f, 1.0f, false);
    protected JSONStorableFloat foreskinmorph4_max_JSON = new JSONStorableFloat("Max Glans", 0.05f, -1.0f, 1.0f, false);

    protected JSONStorableFloat foreskinmorph1_min_temp = new JSONStorableFloat("Min Hoodie Retraction Temp", 0.0f, 0.0f, 1.0f, false);
    protected JSONStorableFloat foreskinmorph2_min_temp = new JSONStorableFloat("Min Hoodie More Retraction Temp", 0.0f, 0.0f, 1.0f, false);
    protected JSONStorableFloat Min_Penis_Skin3Amount_temp = new JSONStorableFloat("Min Shaft Skin Temp", 0.0f, 0.0f, 1.0f, false);
    protected JSONStorableFloat foreskinmorph4_min_temp = new JSONStorableFloat("Glans Temp", 0.0f, 0.0f, 1.0f, false);

    protected JSONStorableFloat _VRhandOffsetXJSON = new JSONStorableFloat("VR Hand Offset X [cm]", -2f, -10f, 10f, false);
    protected JSONStorableFloat _VRhandOffsetYJSON = new JSONStorableFloat("VR Hand Offset Y [cm]", 3f, -10f, 10f, false);
    protected JSONStorableFloat _VRhandOffsetZJSON = new JSONStorableFloat("VR Hand Offset Z [cm]", -1f, -10f, 10f, false);

    protected JSONStorableFloat _handOffsetXJSON = new JSONStorableFloat("Hand Offset X [cm]", 4f, -10f, 10f, false);
    protected JSONStorableFloat _handOffsetYJSON = new JSONStorableFloat("Hand Offset Y [cm]", -4f, -10f, 10f, false);
    protected JSONStorableFloat _handOffsetZJSON = new JSONStorableFloat("Hand Offset Z [cm]", 0f, -10f, 10f, false); 

    protected JSONStorableFloat _mouthOffsetXJSON = new JSONStorableFloat("Mouth Offset X [cm]", 0f, -10f, 10f, false);
    protected JSONStorableFloat _mouthOffsetYJSON = new JSONStorableFloat("Mouth Offset Y [cm]", -2f, -10f, 10f, false);
    protected JSONStorableFloat _mouthOffsetZJSON = new JSONStorableFloat("Mouth Offset Z [cm]", 5f, -10f, 10f, false);

    protected JSONStorableFloat _chestOffsetXJSON = new JSONStorableFloat("Chest Offset X [cm]", 0f, -10f, 10f, false);
    protected JSONStorableFloat _chestOffsetYJSON = new JSONStorableFloat("Chest Offset Y [cm]", 7f, -20f, 20f, false);
    protected JSONStorableFloat _chestOffsetZJSON = new JSONStorableFloat("Chest Offset Z [cm]", 13f, -20f, 20f, false);

    protected JSONStorableFloat _vaginaOffsetXJSON = new JSONStorableFloat("Vagina Offset X [cm]", 1f, -10f, 10f, false);
    protected JSONStorableFloat _vaginaOffsetYJSON = new JSONStorableFloat("Vagina Offset Y [cm]", -4f, -10f, 10f, false);
    protected JSONStorableFloat _vaginaOffsetZJSON = new JSONStorableFloat("Vagina Offset Z [cm]", 4f, -10f, 10f, false);

    protected JSONStorableFloat _anusOffsetXJSON = new JSONStorableFloat("Anus Offset X [cm]", 1f, -10f, 10f, false);
    protected JSONStorableFloat _anusOffsetYJSON = new JSONStorableFloat("Anus Offset Y [cm]", -4f, -10f, 10f, false);
    protected JSONStorableFloat _anusOffsetZJSON = new JSONStorableFloat("Anus Offset Z [cm]", -6f, -10f, 10f, false);

    protected JSONStorableFloat _footOffsetXJSON = new JSONStorableFloat("Toes Offset X [cm]", -1f, -10f, 10f, false);
    protected JSONStorableFloat _footOffsetYJSON = new JSONStorableFloat("Toes Offset Y [cm]", -4f, -10f, 10f, false);
    protected JSONStorableFloat _footOffsetZJSON = new JSONStorableFloat("Toes Offset Z [cm]", 1f, -10f, 10f, false);

    protected JSONStorableFloat _morphSpeedJSON = new JSONStorableFloat("Morph speed", 20f, 0.1f, 100.0f, false);
    protected JSONStorableFloat _activationsensitivityJSON = new JSONStorableFloat("Activation Sensitivity", 0.7f, 0.0f, 1f, false); 
    protected JSONStorableFloat _pullbackintensityJSON = new JSONStorableFloat("Pullback Sensitivity", 3f, 0.0f, 10f, false);
    protected JSONStorableFloat _delayFactorJSON = new JSONStorableFloat("Delay Factor", 0.1f, 0.0f, 0.5f, false); 
    protected JSONStorableFloat intensityTest2 = new JSONStorableFloat("Intensity", 0.0f, 0.0f, 1.0f, false); //For Testing
    protected float testFactor;
    protected bool transient;

    //Code for decent UI menue titles by hazmhox's great VAMMOAN plugin, see https://hub.virtamate.com/threads/vammoan.3692/. 
    private static void disableScrollOnText(UIDynamicTextField target) {
		ScrollRect targetSR = target.UItext.transform.parent.transform.parent.transform.parent.GetComponent<ScrollRect>();
		if( targetSR != null ) {
			targetSR.horizontal = false;
			targetSR.vertical = false;
		}
	}
		
    //Code for decent UI menue titles by hazmhox's great VAMMOAN plugin, see https://hub.virtamate.com/threads/vammoan.3692/. 
	private JSONStorableString createStaticDescriptionText( string DescTitle, string DescText, bool rightSide, int fieldHeight ) {
		JSONStorableString staticDescString = new JSONStorableString(DescTitle,DescText);
		UIDynamicTextField staticDescStringField = CreateTextField(staticDescString, rightSide);
		staticDescStringField.backgroundColor = new Color(1f, 1f, 1f, 0f);
		LayoutElement sdsfLayout = staticDescStringField.GetComponent<LayoutElement>();
		sdsfLayout.preferredHeight = sdsfLayout.minHeight = fieldHeight;
		staticDescStringField.height = fieldHeight;
		disableScrollOnText(staticDescStringField);

		return staticDescString;
	}
    private UIDynamicTextField helpTextfield;

    protected void syncOtherPersonAtoms() // Seach other person atoms for potential foreskin actors
    {
        get_morphs();
        List<Atom> otherPersonAtoms;
        otherPersonAtoms = SuperController.singleton.GetAtoms().Where(atom => atom.type == "Person").ToList(); 

        _otherPersons.Clear();
        foreach (Atom personAtom in otherPersonAtoms)
        {
            OtherPersonInfo personInfo;
            personInfo.PersonAtom = personAtom;
            personInfo.enabled = true;
            personInfo.IsFemale = IsFemale(personAtom);
            personInfo.RHandTarget = personAtom.rigidbodies.First(rb => rb.name == "rCarpal1");
            personInfo.LHandTarget = personAtom.rigidbodies.First(rb => rb.name == "lCarpal1");
            personInfo.RFootTarget = personAtom.rigidbodies.First(rb => rb.name == "rToe");
            personInfo.LFootTarget = personAtom.rigidbodies.First(rb => rb.name == "lToe");
            personInfo.ChestTarget = personAtom.rigidbodies.First(rb => rb.name == "chest");
            personInfo.MouthTarget = personAtom.rigidbodies.First(rb => rb.name == "LipTrigger");
            personInfo.VaginaTarget = personAtom.rigidbodies.First(rb => rb.name == "LabiaTrigger");
            personInfo.AnusTarget = personInfo.VaginaTarget;
            _otherPersons.Add(personInfo);
        }
    }

    public static bool IsFemale(Atom person)
    {
        bool retVal = true;
        DAZCharacter character = person.GetComponentInChildren<DAZCharacter>();
        if (character != null)
        {
            retVal = !character.isMale;
        }
        return retVal;
    }

    public override void Init() //Menu UI initialisation
    {   
        UIDynamicTextField text = null;
        try
        {
            SuperController.LogMessage("Starting RealisticForeskin");

			createStaticDescriptionText("General Config","<color=#000><size=30><b>General Config</b></size></color>",false,35);

            _morphSpeedJSON.storeType = JSONStorableParam.StoreType.Full;
            RegisterFloat(_morphSpeedJSON);
            CreateSlider(_morphSpeedJSON, false);

            _activationsensitivityJSON.storeType = JSONStorableParam.StoreType.Full;
            RegisterFloat(_activationsensitivityJSON);
            CreateSlider(_activationsensitivityJSON, false);

            _delayFactorJSON.storeType = JSONStorableParam.StoreType.Full;
            RegisterFloat(_delayFactorJSON);
            CreateSlider(_delayFactorJSON, false);

            _pullbackintensityJSON.storeType = JSONStorableParam.StoreType.Full;
            RegisterFloat(_pullbackintensityJSON);
            CreateSlider(_pullbackintensityJSON, false);

			createStaticDescriptionText("'Hoodie Retracted' Config","<color=#000><size=30><b>'Hoodie Retracted' Config</b></size></color>",false,35);

            foreskinmorph1_min_JSON_base.storeType = JSONStorableParam.StoreType.Full;
            RegisterFloat(foreskinmorph1_min_JSON_base);
            CreateSlider(foreskinmorph1_min_JSON_base, false);

            foreskinmorph1_max_JSON.storeType = JSONStorableParam.StoreType.Full;
            RegisterFloat(foreskinmorph1_max_JSON);
            CreateSlider(foreskinmorph1_max_JSON, false);

			createStaticDescriptionText("'Hoodie Retracted More' Config","<color=#000><size=30><b>'Hoodie Retracted More' Config</b></size></color>",false,35);

            foreskinmorph2_min_JSON.storeType = JSONStorableParam.StoreType.Full;
            RegisterFloat(foreskinmorph2_min_JSON);
            CreateSlider(foreskinmorph2_min_JSON, false);

            foreskinmorph2_max_JSON.storeType = JSONStorableParam.StoreType.Full;
            RegisterFloat(foreskinmorph2_max_JSON);
            CreateSlider(foreskinmorph2_max_JSON, false);

			createStaticDescriptionText("Shaft Skin Config","<color=#000><size=30><b>Shaft Skin Config</b></size></color>",false,35);

            Red_Penis_Skin3AmountJSON.storeType = JSONStorableParam.StoreType.Full;
            RegisterFloat(Red_Penis_Skin3AmountJSON);
            CreateSlider(Red_Penis_Skin3AmountJSON, false);

            Min_Penis_Skin3AmountJSON.storeType = JSONStorableParam.StoreType.Full;
            RegisterFloat(Min_Penis_Skin3AmountJSON);
            CreateSlider(Min_Penis_Skin3AmountJSON, false);

            Max_Penis_Skin3AmountJSON.storeType = JSONStorableParam.StoreType.Full;
            RegisterFloat(Max_Penis_Skin3AmountJSON);
            CreateSlider(Max_Penis_Skin3AmountJSON, false);

			createStaticDescriptionText("Glans Config","<color=#000><size=30><b>Glans Config</b></size></color>",false,35);

            foreskinmorph4_min_JSON.storeType = JSONStorableParam.StoreType.Full;
            RegisterFloat(foreskinmorph4_min_JSON);
            CreateSlider(foreskinmorph4_min_JSON, false);

            foreskinmorph4_max_JSON.storeType = JSONStorableParam.StoreType.Full;
            RegisterFloat(foreskinmorph4_max_JSON);
            CreateSlider(foreskinmorph4_max_JSON, false);

            text = CreateTextField(new JSONStorableString("text",
				"<size=30><b>How to Use</b></size>\n\n" +
                "<b>Morph Speed:</b> Increase to achieve quick foreskin morph movement.\n\n" +
				"<b>Activation Sensitivity:</b> Sets how close an actor (hand, mouth, etc.) must be to activate retraction. Reduce if retraction does not occur.\n\n" +
				"<b>Delay Factor:</b> Increase to delay the start of retraction.\n\n" +
				"<b>Pullback Sensitivity:</b> Increase to reduce the amount of stroking distance (e.g. by hand) needed to achieve full retraction.\n\n" +
				"<b>Min and Max Morph Config :</b> Set the minimal and maximal retraction state of the different morphs.\n\n" +
				"<b>Shaft Skin Delay & Glans:</b> Use to reduce glans clipping.\n\n" +
				"<b>Testing:</b> Toggle and use slider to preview retraction morphs.\n\n" +
				"<b>Enable Debug:</b> Show debug information in the console.\n\n" +
				"<b>Offset Config: </b> Shift X, Y and Z coordinates of actors (hand, mouth, etc.). Enable debug and reduce actor 'Distance to Tip' at the desired entry point for foreskin retraction."
                ), true);
			text.height = 1215f;
            
			createStaticDescriptionText("Offset Config","<color=#000><size=30><b>Offset Config</b></size></color>",true,35);

            _VRhandOffsetXJSON.storeType = JSONStorableParam.StoreType.Full;
            RegisterFloat(_VRhandOffsetXJSON);
            CreateSlider(_VRhandOffsetXJSON, true);
            _VRhandOffsetYJSON.storeType = JSONStorableParam.StoreType.Full;
            RegisterFloat(_VRhandOffsetYJSON);
            CreateSlider(_VRhandOffsetYJSON, true);
            _VRhandOffsetZJSON.storeType = JSONStorableParam.StoreType.Full;
            RegisterFloat(_VRhandOffsetZJSON);
            CreateSlider(_VRhandOffsetZJSON, true);

            _handOffsetXJSON.storeType = JSONStorableParam.StoreType.Full;
            RegisterFloat(_handOffsetXJSON);
            CreateSlider(_handOffsetXJSON, true);
            _handOffsetYJSON.storeType = JSONStorableParam.StoreType.Full;
            RegisterFloat(_handOffsetYJSON);
            CreateSlider(_handOffsetYJSON, true);
            _handOffsetZJSON.storeType = JSONStorableParam.StoreType.Full;
            RegisterFloat(_handOffsetZJSON);
            CreateSlider(_handOffsetZJSON, true);

            _mouthOffsetXJSON.storeType = JSONStorableParam.StoreType.Full;
            RegisterFloat(_mouthOffsetXJSON);
            CreateSlider(_mouthOffsetXJSON, true);
            _mouthOffsetYJSON.storeType = JSONStorableParam.StoreType.Full;
            RegisterFloat(_mouthOffsetYJSON);
            CreateSlider(_mouthOffsetYJSON, true);
            _mouthOffsetZJSON.storeType = JSONStorableParam.StoreType.Full;
            RegisterFloat(_mouthOffsetZJSON);
            CreateSlider(_mouthOffsetZJSON, true);

            _chestOffsetXJSON.storeType = JSONStorableParam.StoreType.Full;
            RegisterFloat(_chestOffsetXJSON);
            CreateSlider(_chestOffsetXJSON, true);
            _chestOffsetYJSON.storeType = JSONStorableParam.StoreType.Full;
            RegisterFloat(_chestOffsetYJSON);
            CreateSlider(_chestOffsetYJSON, true);
            _chestOffsetZJSON.storeType = JSONStorableParam.StoreType.Full;
            RegisterFloat(_chestOffsetZJSON);
            CreateSlider(_chestOffsetZJSON, true);

            _vaginaOffsetXJSON.storeType = JSONStorableParam.StoreType.Full;
            RegisterFloat(_vaginaOffsetXJSON);
            CreateSlider(_vaginaOffsetXJSON, true);
            _vaginaOffsetYJSON.storeType = JSONStorableParam.StoreType.Full;
            RegisterFloat(_vaginaOffsetYJSON);
            CreateSlider(_vaginaOffsetYJSON, true);
            _vaginaOffsetZJSON.storeType = JSONStorableParam.StoreType.Full;
            RegisterFloat(_vaginaOffsetZJSON);
            CreateSlider(_vaginaOffsetZJSON, true);

            _anusOffsetXJSON.storeType = JSONStorableParam.StoreType.Full;
            RegisterFloat(_anusOffsetXJSON);
            CreateSlider(_anusOffsetXJSON, true);
            _anusOffsetYJSON.storeType = JSONStorableParam.StoreType.Full;
            RegisterFloat(_anusOffsetYJSON);
            CreateSlider(_anusOffsetYJSON, true);
            _anusOffsetZJSON.storeType = JSONStorableParam.StoreType.Full;
            RegisterFloat(_anusOffsetZJSON);
            CreateSlider(_anusOffsetZJSON, true);

            _footOffsetXJSON.storeType = JSONStorableParam.StoreType.Full;
            RegisterFloat(_footOffsetXJSON);
            CreateSlider(_footOffsetXJSON, true);
            _footOffsetYJSON.storeType = JSONStorableParam.StoreType.Full;
            RegisterFloat(_footOffsetYJSON);
            CreateSlider(_footOffsetYJSON, true);
            _footOffsetZJSON.storeType = JSONStorableParam.StoreType.Full;
            RegisterFloat(_footOffsetZJSON);
            CreateSlider(_footOffsetZJSON, true);

			createStaticDescriptionText("Testing","<color=#000><size=30><b>Testing</b></size></color>",false,35);

            enableTesting = new JSONStorableBool("Enable Testing", false);
			enableTesting.storeType = JSONStorableParam.StoreType.Full;
			CreateToggle(enableTesting, false);
			RegisterBool(enableTesting);

            intensityTest2.storeType = JSONStorableParam.StoreType.Full;
            RegisterFloat(intensityTest2);
            CreateSlider(intensityTest2, false);

            debug = new JSONStorableBool("Enable Debug", false);
			debug.storeType = JSONStorableParam.StoreType.Full;
			CreateToggle(debug, false);
			RegisterBool(debug);

            StartCoroutine(WaitForLoadingComplete());

            _penisBase = containingAtom.freeControllers.First(fc => fc.name == "penisBaseControl");
            _penisTip = containingAtom.freeControllers.First(fc => fc.name == "penisTipControl");    
        }
        catch (Exception e)
        {
            SuperController.LogError($"{nameof(RealisticForeskin)}.{nameof(Init)}: {e}");
        }
    }

    private void get_morphs() //Loading morphs
    {
        if(isSceneLoaded)
        {
            morphs_got=false;
        
            Selector = containingAtom.GetComponentInChildren<DAZCharacterSelector>();
            foreskinbasemorph_choice = Selector.morphsControlMaleUI.GetMorphByUid("Jackaroo.Hoodie_Retracted_More.7:/Custom/Atom/Person/Morphs/male_genitalia/Hoodie_Shaftonly_Thinner.vmi");
            foreskinbasemorph_choice.morphValue = 1f; //activate hoodie morph

            foreskinmorph1_choice = Selector.morphsControlMaleUI.GetMorphByUid("Jackaroo.Hoodie_Retracted_More.7:/Custom/Atom/Person/Morphs/male_genitalia/Hoodie_Retracted.vmi");  
            foreskinmorph2_choice = Selector.morphsControlMaleUI.GetMorphByUid("Jackaroo.Hoodie_Retracted_More.7:/Custom/Atom/Person/Morphs/male_genitalia/Hoodie_Retracted_More.vmi");
            foreskinmorph3_choice = Selector.morphsControlMaleUI.GetMorphByUid("VamTastic.Penis_Skin_morphs.1:/Custom/Atom/Person/Morphs/male_genitalia/VamTastic/Penis_Skin3.vmi");
            foreskinmorph4_choice = Selector.morphsControlMaleUI.GetMorphByUid("Gl_Big");

            foreskinmorph1_choice.morphValue = foreskinmorph1_min_JSON_base.val; //initialisation of morph state after loading
            foreskinmorph2_choice.morphValue = foreskinmorph2_min_JSON.val;
            foreskinmorph3_choice.morphValue = Min_Penis_Skin3AmountJSON.val;
            foreskinmorph4_choice.morphValue = foreskinmorph4_min_JSON.val;

            share_of_targetDistance = 0;
      
            if (foreskinbasemorph_choice == null)
                {
                SuperController.LogError("Missing Hoodie Morphs. Please download Jackaroo's Hoodie Morphs\nhttps://hub.virtamate.com/resources/hoodie-morphs-and-textures.38516/");
                    DestroyImmediate(this);
                return;
                }
            else
                {
                morphs_got=true;
                }
        }
    }

    private IEnumerator WaitForLoadingComplete()
    {
        while (SuperController.singleton.isLoading)
        {
            isSceneLoaded = false;
            yield return null;
        }

        while (SuperController.singleton.freezeAnimation)
        {
            isSceneLoaded = false;
            yield return null;
        }

        yield return null;

        isSceneLoaded = true;
            syncOtherPersonAtoms();
    }

    public void OnEnable()
    {
        try
        {
            syncOtherPersonAtoms();
        }
        catch (Exception e)
        {
            SuperController.LogError($"{nameof(RealisticForeskin)}.{nameof(OnEnable)}: {e}");
        }
    }

    public void OnDestroy()
    {
        try
        {
            cleanup();
        }
        catch (Exception e)
        {
            SuperController.LogError($"{nameof(RealisticForeskin)}.{nameof(OnDestroy)}: {e}");
        }
    }

    public void OnDisable()
    {
        try
        {
            cleanup();
        }
        catch (Exception e)
        {
            SuperController.LogError($"{nameof(RealisticForeskin)}.{nameof(OnDisable)}: {e}");
        }
    }

    public void cleanup()
    {
        {
            foreskinbasemorph_choice.morphValue = 0f;
            foreskinmorph1_choice.morphValue = 0f;
            foreskinmorph2_choice.morphValue = 0f;
            foreskinmorph3_choice.morphValue = 0f;
            foreskinmorph4_choice.morphValue = 0f;
        }
    }

    public Vector3 GetOffset(string targetType) //Individual actor offsets from original control / rigidbody positions
    {
        Vector3 offset = new Vector3(0f, 0f, 0f);
        
        if (targetType == "rHand")
        {
            offset =  new Vector3(_handOffsetXJSON.val, _handOffsetYJSON.val, _handOffsetZJSON.val);
        }
        else if (targetType == "lHand")
        {
            // swap x axis for left hand
            offset =  new Vector3(-_handOffsetXJSON.val, _handOffsetYJSON.val, _handOffsetZJSON.val);
        }
        else if (targetType == "rightVRHand")
        {
            offset =  new Vector3(_VRhandOffsetXJSON.val, _VRhandOffsetYJSON.val, _VRhandOffsetZJSON.val);
        }
        else if (targetType == "leftVRHand")
        {
            // swap x axis for left hand
            offset =  new Vector3(-_VRhandOffsetXJSON.val, _VRhandOffsetYJSON.val, _VRhandOffsetZJSON.val);
        }
        else if (targetType == "Chest")
        {
            offset = new Vector3( _chestOffsetXJSON.val, _chestOffsetYJSON.val, _chestOffsetZJSON.val);
        }
        else if (targetType == "Mouth")
        {
            offset = new Vector3( _mouthOffsetXJSON.val, _mouthOffsetYJSON.val, _mouthOffsetZJSON.val);
        }
        else if (targetType == "Vagina")
        {
            offset =  new Vector3(_vaginaOffsetXJSON.val, _vaginaOffsetYJSON.val, _vaginaOffsetZJSON.val);
        }
        else if (targetType == "Anus")
        {
            offset =  new Vector3(_anusOffsetXJSON.val, _anusOffsetYJSON.val, _anusOffsetZJSON.val);
        }
        else if (targetType == "rFoot")
        {
            offset =  new Vector3(_footOffsetXJSON.val, _footOffsetYJSON.val, _footOffsetZJSON.val);
        }
        else if (targetType == "lFoot")
        {
            // swap x axis for left Foot
            offset =  new Vector3(-_footOffsetXJSON.val, _footOffsetYJSON.val, _footOffsetZJSON.val);
        }
        return offset * 0.01f; // cm to m
    }

    protected void potentialForeskinTargetUpdate(Component potentialTarget, string targetType, Atom PersonAtom)
    {
        targetOffset = GetOffset(targetType); //Getting individual actor offset
        
        //Calculating (sum of) distances to tip and base of current actor incl. offset
        targetDistance = (_penisBase.transform.position - potentialTarget.transform.TransformPoint(targetOffset)).magnitude;
        sumtargetDistance = (targetDistance + (_penisTip.transform.position - potentialTarget.transform.TransformPoint(targetOffset)).magnitude); 
        tiptargetDistance = (_penisTip.transform.position - potentialTarget.transform.TransformPoint(targetOffset)).magnitude;

        targetIsNearer = tiptargetDistance < tiptargetDistance1; //Checking if actor is closer than closest actor at last frame (BOOL)
        if (targetIsNearer) //If true, actor is set
        {
            tiptargetDistance1 = tiptargetDistance;
            sumtargetDistance1 = sumtargetDistance;
            
            //SuperController.LogMessage("targetType: " + targetType); //+ " - selected: " + tiptargetDistance1
        }
    }

    protected void syncPenisTarget() // Seaching of closest actor
    {
        try
        {   //Distance tip to base (penis length)
            _targetTipToBaseDistance = (_penisBase.transform.position - _penisTip.transform.position).magnitude;

            //Initialisation distance to get closest actor
            tiptargetDistance1 = 0.5f;
            targetIsNearer = true;
            
            //Measuring of distance of all actors (except VR hands), output as "targetDistance" (incl. offset)
            foreach (OtherPersonInfo personInfo in _otherPersons)
            {
                if(personInfo.PersonAtom != containingAtom)
                {
                    potentialForeskinTargetUpdate(personInfo.ChestTarget, "Chest", personInfo.PersonAtom);
                    potentialForeskinTargetUpdate(personInfo.VaginaTarget, "Vagina", personInfo.PersonAtom);
                    potentialForeskinTargetUpdate(personInfo.AnusTarget, "Anus", personInfo.PersonAtom);
                    potentialForeskinTargetUpdate(personInfo.RFootTarget, "rFoot", personInfo.PersonAtom);
                    potentialForeskinTargetUpdate(personInfo.LFootTarget, "lFoot", personInfo.PersonAtom);
                }
                potentialForeskinTargetUpdate(personInfo.RHandTarget, "rHand", personInfo.PersonAtom);
                potentialForeskinTargetUpdate(personInfo.LHandTarget, "lHand", personInfo.PersonAtom);
                potentialForeskinTargetUpdate(personInfo.MouthTarget, "Mouth", personInfo.PersonAtom);
            }
            
            //(Sum of) distances to tip and base of left VR hand (incl. offset)
            targetOffset = GetOffset(targetType="leftVRHand");
            targetDistance2 = (_penisBase.transform.position - SuperController.singleton.leftHand.transform.TransformPoint(targetOffset)).magnitude;
            sumtargetDistance2 = (targetDistance2 + (_penisTip.transform.position - SuperController.singleton.leftHand.transform.TransformPoint(targetOffset)).magnitude);
            tiptargetDistance2 = (_penisTip.transform.position - SuperController.singleton.leftHand.transform.TransformPoint(targetOffset)).magnitude;
            
            //(Sum of) distances to tip and base of right VR hand (incl. offset)
            targetOffset = GetOffset(targetType="rightVRHand");
            targetDistance3 = targetDistance3 = (_penisBase.transform.position - SuperController.singleton.rightHand.transform.TransformPoint(targetOffset)).magnitude;
            sumtargetDistance3 = (targetDistance3 + (_penisTip.transform.position - SuperController.singleton.rightHand.transform.TransformPoint(targetOffset)).magnitude);
            tiptargetDistance3 = (_penisTip.transform.position - SuperController.singleton.rightHand.transform.TransformPoint(targetOffset)).magnitude;

            //Selecting closest foreskin actor to tip (incl. VR hands) 
            tiptargetDistance_selected = Mathf.Min(tiptargetDistance1, tiptargetDistance2, tiptargetDistance3);

            //Selecting closest sum of distances
            sumtargetDistance_selected = Mathf.Min(sumtargetDistance1, sumtargetDistance2, sumtargetDistance3);

            //Share of distance from tip (towards base) of closest actor as raw input for foreskin retraction amount
            share_of_targetDistance = tiptargetDistance_selected / sumtargetDistance_selected;  

            //Get current erection level from 'Realistic Foreskin' Plugin (if installed) and set new foreskin minimum based on erection level
            var pluginId = containingAtom.GetStorableIDs().FirstOrDefault(id => id.EndsWith("RunRudolf.RealisticErection")); //Plugin number of Realistic Erection in PluginManager

            if (pluginId == null)
                {
                    //SuperController.LogError("Missing 'Realistic Erection' Plugin. Some functions are not available");
                    erection = 0f;
                }
            else
                {
                    erection = containingAtom.GetStorableByID(pluginId).GetFloatParamValue("Erection Level"); //Current erection level from plugin 'Realistic Erection' from 0 to 1
                    foreskinmorph1_min_JSON.val = foreskinmorph1_min_JSON_base.val + (erection / 1.7f) * (foreskinmorph1_max_JSON.val - foreskinmorph1_min_JSON_base.val); //Setting new min foreskin morphs based on erection level
                    //SuperController.LogMessage("New min Morph 1 based on erection: " + foreskinmorph1_min_JSON.val.ToString("F2"));
                }         
        }
        catch (Exception e)
        {
            SuperController.LogError($"{nameof(RealisticForeskin)}.{nameof(syncPenisTarget)}: {e}");
        }
    }

    // FixedUpdate is called with each physics simulation frame by Unity
    void FixedUpdate()
    {
        if(isSceneLoaded) {
        try
            {  
                syncPenisTarget();

                if (enableTesting.val == true) //Testmode injection
				{
                    share_of_targetDistance = intensityTest2.val;
                    testFactor = 0f;
                }
                else
                {
                    testFactor = 1f;
                }
                
                if((sumtargetDistance_selected * _activationsensitivityJSON.val * testFactor) < _targetTipToBaseDistance) //Active and transient state
                {
                    var check = (share_of_targetDistance - _delayFactorJSON.val) * _pullbackintensityJSON.val; //Current calculated foreskin share state
                    if (transient == true && ((check - last_foreskinmorph1_choice_inactive > 0.1f) || (check - last_foreskinmorph1_choice_inactive < -0.1f))) //Transition state (if difference between last reportet foreskin state and current calculated state is larger than threshold value)
                    {
                        //Do nothing in transient state but adjust min retraction based on erection level
                        
                        if (debug.val == true) //Debug variable output
                        {
                            var check2 = (check - last_foreskinmorph1_choice_inactive);
                            SuperController.LogMessage("Transient State. Erection: " + erection.ToString("F2") + " Transient: - Last: " + last_foreskinmorph1_choice_inactive.ToString("F2") + " - Difference: " + check2.ToString("F2"));
                        }
                    }
                    else //Active state
                    {
                        //Foreskin state calculation (normal case)
                        foreskinmorph1_choice.morphValue = Mathf.Lerp(foreskinmorph1_choice.morphValue, Mathf.Clamp((share_of_targetDistance - _delayFactorJSON.val) * _pullbackintensityJSON.val, foreskinmorph1_min_JSON_base.val, foreskinmorph1_max_JSON.val), _morphSpeedJSON.val * Time.deltaTime); //Hoodie Retracted function   
                        foreskinmorph2_choice.morphValue = Mathf.Lerp(foreskinmorph2_choice.morphValue, Mathf.Clamp((share_of_targetDistance - _delayFactorJSON.val - Red_Penis_Skin3AmountJSON.val) * _pullbackintensityJSON.val, foreskinmorph2_min_JSON.val, foreskinmorph2_max_JSON.val), _morphSpeedJSON.val * Time.deltaTime); //Hoodie Retracted More function
                        foreskinmorph3_choice.morphValue = Mathf.Lerp(foreskinmorph3_choice.morphValue, Mathf.Clamp((share_of_targetDistance - _delayFactorJSON.val - Red_Penis_Skin3AmountJSON.val) * _pullbackintensityJSON.val, Min_Penis_Skin3AmountJSON.val, Max_Penis_Skin3AmountJSON.val), _morphSpeedJSON.val * Time.deltaTime); //Shaft Skin function
                        foreskinmorph4_choice.morphValue = foreskinmorph4_min_JSON.val + (foreskinmorph4_max_JSON.val - foreskinmorph4_min_JSON.val) * foreskinmorph1_choice.morphValue; //Glans function

                        //Write last normal case foreskin states to be used in 'transient case' check
                        last_foreskinmorph1_choice_inactive = foreskinmorph1_choice.morphValue; 
                        last_foreskinmorph2_choice_inactive = foreskinmorph2_choice.morphValue;
                        last_foreskinmorph3_choice_inactive = foreskinmorph3_choice.morphValue;
                        last_foreskinmorph4_choice_inactive = foreskinmorph4_choice.morphValue;
                        transient = false; //Do not switch back to transient state, only inactive possible

                        //SuperController.LogMessage("Check: " + check + " Erection: " + erection.ToString("F2") + " Normal: Morph 1: " + foreskinmorph1_choice.morphValue.ToString("F2") + "/" + foreskinmorph1_min_temp.val.ToString("F2") + " - Morph 2: " + foreskinmorph2_choice.morphValue.ToString("F2") + "/" + foreskinmorph2_min_temp.val.ToString("F2") + " - Morph 3: " + foreskinmorph3_choice.morphValue.ToString("F2")+"/" + Min_Penis_Skin3Amount_temp.val.ToString("F2"));
                    }
                    if (debug.val == true) //Debug variable output
                    {
                        //SuperController.LogMessage("Distance to Tip: " + tiptargetDistance_selected.ToString("F3") + " m");
                        //SuperController.LogMessage("IF 'Sum of Distances Target-Tip x 'Activation Sensitivity': " + (sumtargetDistance_selected * _activationsensitivityJSON.val).ToString("F2") + " m < 'Length Tip-Base': " + _targetTipToBaseDistance.ToString("F2") + " m THEN 'active'."); 
                        //SuperController.LogMessage("Amount of Retraction: Share of Target Distance " + (share_of_targetDistance).ToString("F2") + " m" + " - 'Delay Factor' * 'Intensity Factor'= " + ((share_of_targetDistance - _delayFactorJSON.val) * _pullbackintensityJSON.val).ToString("F2"));
                        SuperController.LogMessage("Active State. Erection: " + erection.ToString("F2") + "Hoodie: " + foreskinmorph1_choice.morphValue.ToString("F2") + " - Hoodie more: " + foreskinmorph2_choice.morphValue.ToString("F2") + " - Skin3: " + foreskinmorph3_choice.morphValue.ToString("F2") + " - Glans: " + foreskinmorph4_choice.morphValue.ToString("F2"));
                    }
                }
                else //Inactive state (no target in range, foreskin will move to relaxed state on its own)
                { 
                    //Define end foreskin relaxed end state in inactive case depending on erection level from plugin 'Realistic Erection'
                    foreskinmorph1_min_temp.val = Mathf.Clamp(0.7f * erection, foreskinmorph1_min_JSON.val, foreskinmorph1_max_JSON.val); 
                    foreskinmorph2_min_temp.val = Mathf.Clamp(0.7f * erection, foreskinmorph2_min_JSON.val, foreskinmorph2_max_JSON.val);
                    Min_Penis_Skin3Amount_temp.val = Mathf.Clamp(0.7f * erection, Min_Penis_Skin3AmountJSON.val, Max_Penis_Skin3AmountJSON.val); 

                    if (foreskinmorph1_choice.morphValue > foreskinmorph1_min_temp.val)
                    {
                        //Foreskin state calculation (inactive case, closing)
                        foreskinmorph1_choice.morphValue = Mathf.Lerp(foreskinmorph1_choice.morphValue, foreskinmorph1_min_temp.val, _morphSpeedJSON.val / 20f * Time.deltaTime); //Hoodie Retracted function   
                        foreskinmorph2_choice.morphValue = Mathf.Lerp(foreskinmorph2_choice.morphValue, foreskinmorph2_min_temp.val - Red_Penis_Skin3AmountJSON.val, _morphSpeedJSON.val / 10f * Time.deltaTime); //Hoodie Retracted More function
                        foreskinmorph3_choice.morphValue = Mathf.Lerp(foreskinmorph3_choice.morphValue, Min_Penis_Skin3Amount_temp.val - Red_Penis_Skin3AmountJSON.val, _morphSpeedJSON.val / 10f * Time.deltaTime); //Shaft Skin function
                        foreskinmorph4_choice.morphValue = foreskinmorph4_min_JSON.val + (foreskinmorph4_max_JSON.val - foreskinmorph4_min_JSON.val) * foreskinmorph1_choice.morphValue; //Glans function if not active
                    }
                    else
                    {
                        //Foreskin state calculation (inactive case, retracting)
                        foreskinmorph1_choice.morphValue = Mathf.Lerp(foreskinmorph1_choice.morphValue, foreskinmorph1_min_temp.val, _morphSpeedJSON.val / 10f * Time.deltaTime); //Hoodie Retracted function   
                        foreskinmorph2_choice.morphValue = Mathf.Lerp(foreskinmorph2_choice.morphValue, foreskinmorph2_min_temp.val - Red_Penis_Skin3AmountJSON.val, _morphSpeedJSON.val / 20f * Time.deltaTime); //Hoodie Retracted More function
                        foreskinmorph3_choice.morphValue = Mathf.Lerp(foreskinmorph3_choice.morphValue, Min_Penis_Skin3Amount_temp.val - Red_Penis_Skin3AmountJSON.val, _morphSpeedJSON.val / 20f * Time.deltaTime); //Shaft Skin function
                        foreskinmorph4_choice.morphValue = foreskinmorph4_min_JSON.val + (foreskinmorph4_max_JSON.val - foreskinmorph4_min_JSON.val) * foreskinmorph1_choice.morphValue; //Glans function if not active  
                    }
                    //Write last inactive case foreskin states to be used in 'transition case'
                    last_foreskinmorph1_choice_inactive = foreskinmorph1_choice.morphValue; 
                    last_foreskinmorph2_choice_inactive = foreskinmorph2_choice.morphValue;
                    last_foreskinmorph3_choice_inactive = foreskinmorph3_choice.morphValue;
                    last_foreskinmorph4_choice_inactive = foreskinmorph4_choice.morphValue;
                    transient = true; //Go to transient state if activated

                    if (debug.val == true) //Debug variable output
                    {    
                        SuperController.LogMessage("Inactive State. Erection: " + erection.ToString("F2") + "Hoodie: " + foreskinmorph1_choice.morphValue.ToString("F2") + " - Hoodie more: " + foreskinmorph2_choice.morphValue.ToString("F2") + " - Skin3: " + foreskinmorph3_choice.morphValue.ToString("F2") + " - Glans: " + foreskinmorph4_choice.morphValue.ToString("F2"));
                        //SuperController.LogMessage("Erection: " + erection.ToString("F2") + "Inaktiv: Morph 1: " + foreskinmorph1_choice.morphValue.ToString("F2") + "/" + foreskinmorph1_min_temp.val.ToString("F2") + " - Morph 2: " + foreskinmorph2_choice.morphValue.ToString("F2") + "/" + foreskinmorph2_min_temp.val.ToString("F2") + " - Morph 3: " + foreskinmorph3_choice.morphValue.ToString("F2")+"/" + Min_Penis_Skin3Amount_temp.val.ToString("F2"));
                    }
                }
            }
        catch (Exception e)
            {
                SuperController.LogError($"{nameof(RealisticForeskin)}.{nameof(FixedUpdate)}: {e}");
            }
        }
    }
}
}
